using Blazorise.DataGrid;
using Microsoft.AspNetCore.Components;
using Microsoft.Extensions.Localization;
using Microsoft.Extensions.Logging;
using System.Security.Claims;
using WF_WebAdmin.Model;
using WF_WebAdmin.Service;

namespace WF_WebAdmin.Pages
{
    public partial class ValidQuiz
    {
        private List<Quiz> quizzes;
        [Inject]
        public ILogger<ValidQuiz> Logger { get; set; }

        [Inject]
        public IStringLocalizer<ValidQuiz> Localizer { get; set; }

        [Inject]
        public HttpClient Http { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }
        
        [Inject]
        public IQuizService QuizService { get; set; }

        protected override async Task OnInitializedAsync()
        {
            quizzes = await QuizService.getQuizzesToValidate();
        }

        private void OnValidButton(Quiz quiz)
        {
            ValidateQuiz(quiz);
        }
        
        private void ValidateQuiz(Quiz quiz)
        {
            LoggerSaveStub.Log(Logger, LogLevel.Information, $"Quiz {quiz.Id} validated!");

            Console.WriteLine($"Quiz {quiz.Id} validated!");
            
            Quiz newQuiz = quiz;
            newQuiz.IsValid = true;

            // Mis à jour de l'état du quiz
            QuizService.updateQuiz(quiz);
        }

        private void OnRejectButton(Quiz quiz)
        {
            RejectQuiz(quiz);
        }

        private void RejectQuiz(Quiz quiz)
        {
            LoggerSaveStub.Log(Logger, LogLevel.Information, $"Quiz {quiz.Id} rejected!");

            Console.WriteLine($"Quiz {quiz.Id} rejected!");

            QuizService.removeQuiz(quiz.Id);
        }
    }
}